%%% This m file is for getting the GW predictors.



%% Load Goyal-Welch quarterly data, 1947Q1-2016Q4

input_file='PredictorData2016.xlsx';
input_sheet='Quarterly';

Rfree=xlsread(input_file,input_sheet,'l305:l584');
% Rfree=xlsread(input_file,input_sheet,'l306:l585');
R_SP500=xlsread(input_file,input_sheet,'s306:s585');
% r=log(1+R_SP500)-log(1+Rfree);
r=R_SP500-Rfree;

% (1) Log dividend-price ratio
SP=xlsread(input_file,input_sheet,'b306:b585');
D12=xlsread(input_file,input_sheet,'c306:c585');
log_DP=log(D12./SP);

% (2) Log dividend yield
SP_lag=xlsread(input_file,input_sheet,'b305:b584');
log_DY=log(D12./SP_lag);

% (3) Log earnings-price ratio
E12=xlsread(input_file,input_sheet,'d306:d585');
log_EP=log(E12./SP);

% (4) Log dividend-payout ratio
log_DE=log(D12./E12);

% (5) Stock excess return volatility (annualized)
SVAR=xlsread(input_file,input_sheet,'p306:p585');

% (6) Book-to-market ratio
BM=xlsread(input_file,input_sheet,'e306:e585');

% (7) Net equity issuance
NTIS=xlsread(input_file,input_sheet,'k306:k585');

% (8) Treasury bill rate (annualized)
TBL=xlsread(input_file,input_sheet,'f306:f585');

% (9) Long-term yield (annualized)
LTY=xlsread(input_file,input_sheet,'i306:i585');

% (10) Long-term return
LTR=xlsread(input_file,input_sheet,'n306:n585');

% (11) Term spread (annualized)
TMS=LTY-TBL;

% (12) Default yield spread (annualized)
BAA=xlsread(input_file,input_sheet,'h306:h585');
AAA=xlsread(input_file,input_sheet,'g306:g585');
DFY=BAA-AAA;

% (13) Default return spread
CORPR=xlsread(input_file,input_sheet,'o306:o585');
DFR=CORPR-LTR;

% (14) Inflation (lagged, to account for data release)
INFL_lag=xlsread(input_file,input_sheet,'m305:m584');

% (15) Investment to capital ratio
IK=xlsread(input_file,input_sheet,'r306:r585');


GW=[log_DP log_DY log_EP log_DE SVAR BM NTIS TBL LTY LTR TMS DFY DFR ...
    INFL_lag IK];
save('data2016.mat','GW','r','Rfree');
