%%% This m file generates the figure 1-7 in the paper


%% figure 1
t = 1:1:q(1)-q0;
figure (1);
for i = 1:K
    subplot(4,4,i)
    plot(t,cumerror_dif1(:,i),'k')
    hold on
    plot(t,zeros(length(t),1),'k')
    ylim([-0.1 0.1])
    yticks([-0.1:0.05:0.1])
    xlim([1 164])
    xticks([21:40:141])
    xticklabels(1970:10:2000)
    title(variablename1(i),'FontSize',10,'FontWeight','normal')
end
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure1','epsc');


%% figure 2
figure (2);
for i = 1:5
    subplot(2,3,i)
    plot(t,cumerror_dif2(:,i),'k')
    hold on
    plot(t,zeros(length(t),1),'k')
    ylim([-0.1 0.1])
    yticks([-0.1:0.05:0.1])
    xlim([1 164])
    xticks([21:40:141])
    xticklabels(1970:10:2000)
    title(variablename2(i),'FontSize',10,'FontWeight','normal')
end
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure2','epsc');


%% figure 3
figure (3);
for i = 1:16
    subplot(4,4,i)
    plot(t,forecast(:,i),'k')
    hold on
    plot(t,zeros(length(t),1))
    plot(t,forecast_historical,':k')
    ylim([-0.1 0.1])
    yticks([-0.1:0.05:0.1])
    xlim([1 164])
    xticks([21:40:141])
    xticklabels(1970:10:2000)
    title(variablename(i),'FontSize',10,'FontWeight','normal')
end
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure3','epsc');


%% figure 4
forecast_variance = [var(forecast) var(forecast_historical)];
forecast_bias = (kron(ones(1,size(forecast,2)+1),r(end-q(1)+q0+1:end))-[forecast forecast_historical]).^2;
forecast_bias = mean(forecast_bias);

figure (4);
scatter(forecast_bias([1:16 21]),forecast_variance([1:16 21]),'filled')
for ii = 1:16
    text(forecast_bias(ii)+.000005, forecast_variance(ii),variablename{ii},'FontSize',8) 
end
text(forecast_bias(21)+.000005, forecast_variance(21),variablename{21},'FontSize',8)
xlabel('Squared forecast bias')
ylabel('Forecast variance')
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure4','epsc');


%% figure 5
figure (5);
plot(t,forecast(:,16),'k')
hold on
plot(t,zeros(length(t),1),'k')
plot(t,forecast_historical,':k')
plot(t,forecast_KS,'--k')
ylim([-0.1 0.2])
yticks([-0.1:0.05:0.2])
xlim([1 164])
xticks([21:40:141])
xticklabels(1970:10:2000)
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure5','epsc');


%% figure 6
t1 = datetime(1965,1,1);
dates = dateshift(t1,'start','month',0:491);
dates = dates(1:3:end);
dates = datenum(dates);

figure (6);
plot(dates,forecast(:,16),'k')
hold on
plot(dates,zeros(length(t),1),'k')
plot(dates,forecast_historical,':k')
ylim([-0.02 0.06])
yticks([-0.02:0.02:0.06])
xlim([dates(1) dates(end)])
xticks([dates(21:40:141)])
xticklabels(1970:10:2000)
recessionplot
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure6','epsc');


%% figure 7
corr_GW_r = nan(length(r)-window,K);
corr_GW_r_UB = nan(length(r)-window,K);
corr_GW_r_LB = nan(length(r)-window,K);
for i = 1:length(r)-window
    for k = 1:K
        [R,~,RL,RU] = corrcoef(GW(i:window+i-1,k),r(i+1:window+i));
        corr_GW_r(i,k) = R(1,2);
        corr_GW_r_LB(i,k) = RL(1,2);
        corr_GW_r_UB(i,k) = RU(1,2);
    end
end

t = 1:length(r)-window;
figure (7);
for i = 1:K
    subplot(4,4,i)
    plot(t,corr_GW_r(:,i),'k')
    hold on
    plot(t,zeros(length(t),1),'k')
    plot(t,corr_GW_r_LB(:,i),':k')
    plot(t,corr_GW_r_UB(:,i),':k')
    ylim([-1 1])
    yticks([-1:0.5:1])
    xlim([1 t(end)])
    xticks([13:40:173])
    xticklabels(1960:10:2000)
    title(variablename1(i),'FontSize',10,'FontWeight','normal')
end
set(gcf,'Position',[0 0 1000 600]);
saveas(gcf,'output\figure7','epsc');
